///////////////////////////////////////////////////////////////////////////////
// ControllerMain.h
// ================
// Derived Controller class for main window
//
//  AUTHOR: Song Ho Ahn (song.ahn@gmail.com)
// CREATED: 2006-07-09
// UPDATED: 2019-01-23
///////////////////////////////////////////////////////////////////////////////

#ifndef WIN_CONTROLLER_MAIN_H
#define WIN_CONTROLLER_MAIN_H

#include "Controller.h"
#include "View.h"

namespace Win
{
    class ControllerMain :public Controller
    {
    public:
        ControllerMain() {};                        // ctor
        ~ControllerMain() {};                       // dtor

        int create();                               // for WM_CREATE
        int command(int id, int cmd, LPARAM msg);   // for WM_COMMAND
        int contextMenu(HWND handle, int x, int y); // for WM_CONTEXTMENU: handle, x, y
        int close();                                // for WM_CLOSE
        int destroy();                              // for WM_DESTROY
        int notify(int id, LPARAM lParam);          // for WM_NOTIFY: controllerID, NMHDR
        int mouseMove(WPARAM state, int x, int y);  // for WM_MOUSEMOVE: state, x, y
        int lButtonUp(WPARAM state, int x, int y);  // for WM_LBUTTONUP: state, x, y

    private:
        //Win::Model model;
        Win::View  view;

    };
}

#endif
